"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = exports.program = exports.map = exports.html = exports.URI = void 0;
const pipeable_1 = require("fp-ts/lib/pipeable");
const R = __importStar(require("fp-ts-rxjs/lib/Observable"));
const sub = __importStar(require("./Sub"));
const platform = __importStar(require("./Platform"));
exports.URI = 'effe-ts/Html';
exports.html = {
    URI: exports.URI,
    map: (fa, f) => dispatch => fa(a => dispatch(f(a)))
};
const { map } = pipeable_1.pipeable(exports.html);
exports.map = map;
function program(init, update, view, subscriptions = sub.none) {
    return env => {
        const { dispatch, action$, model$ } = platform.program(init, update, subscriptions)(env);
        const html$ = pipeable_1.pipe(model$, R.map(model => view(model)));
        return { dispatch, action$, model$, html$ };
    };
}
exports.program = program;
function run(program, renderer, env) {
    const p = program(env);
    p.html$.subscribe(html => renderer(html(p.dispatch)));
    return platform.run(() => p, env);
}
exports.run = run;
//# sourceMappingURL=Html.js.map